package CatalystX::state51::ControllerRole::Form;
use MooseX::MethodAttributes::Role;
use MooseX::Types::Moose qw/HashRef ArrayRef/;
use MooseX::Types::LoadableClass qw/ LoadableClass /;
use List::MoreUtils qw/ any /;
use Moose::Autobox;
use Method::Signatures::Simple;
use Carp qw/ confess /;
use Try::Tiny;
use namespace::autoclean;

has form_class => (
    isa => LoadableClass,
    is => 'ro',
    coerce => 1,
    required => 1,
    handles => {
        get_form_instance => 'new',
    }
);

has form_fields => (
    isa => HashRef,
    required => 1,
    traits    => ['Hash'],
    handles   => {
        get_form_field_map => 'get',
    },
    default => sub { {} },
);

has fif_ignore_fields => (
    is => 'ro',
    isa => ArrayRef,
    default => sub { return [] },
);

1;

