package CatalystX::state51::Plugin::ReportErrors;
use strict;
use warnings;
use MRO::Compat;

use base qw/ Catalyst::Plugin::ErrorCatcher Catalyst::Plugin::StackTrace Catalyst::Component /;

$::REPORT_ERRORS_IN_RT = ($ENV{REPORT_ERRORS_IN_RT} ? 1 : 0 )
    if ! defined $::REPORT_ERRORS_IN_RT;

sub setup {
    my $app = shift;
    $app->config(
        stacktrace => {
            enable => 1,
        },
        'Plugin::ErrorCatcher' => {
            enable => $::REPORT_ERRORS_IN_RT,
            context => 5,
            always_log => 0,
            emit_module => 'CatalystX::state51::ErrorCatcher::RT',
        },
        'CatalystX::state51::ErrorCatcher::RT' => {
            server => 'http://support.openimp.com',
            username => 'platform',
            password => 'cifVukghib',
            queue => 'platform-support'
        },
    );
    $app->next::method(@_);
}

sub finalize_error {
    my ($c, @args) = @_;
    if ($c->debug) {
        local $c->_errorcatcher_cfg->{enable} = 0;
        return $c->next::method(@args);
    }
    $c->my_finalize_error if $::REPORT_ERRORS_IN_RT;
    $c->response->content_type('text/html; charset=utf-8');
    $c->response->body($c->view('HTML')->render($c, 'error500.tt'));
    $c->response->status(500);
}

1;

