package CatalystX::state51::StandardRoot;
use MooseX::MethodAttributes ();
use Moose::Role -traits => 'MethodAttributes';
use namespace::autoclean;

our $VERSION = '0.023';

sub root : Chained('/') PathPart('') CaptureArgs(0) { }

sub root_auth : Chained('root') PathPart('') CaptureArgs(0) {
    my ($self, $c) = @_;
    unless ($c->authenticate({ realm => $c->config->{name} })) {
        $c->forward('/error401');
    }
}

sub root_noauth : Chained('root') PathPart('') CaptureArgs(0) { }

sub index_page : Chained('root_auth') PathPart('') Args() {
    my ($self, $c, @args) = @_;
    $c->detach('/error404')
        if (scalar @args && !$c->res->has_body);
    $c->stash->{template} ||= 'index.tt';
}

1;

