package CatalystX::state51::ViewRole::ImproveThisPage;
use Moose::Role;
use Try::Tiny;
use Moose::Autobox;
use JSON;
use MIME::Base64 qw(encode_base64);
use Encode qw(encode);
use namespace::autoclean;

requires 'expose_methods';

around expose_methods => sub {
    my ($orig, $self, @args) = @_;
    my $m = $self->$orig(@args) || [];
    [ $m->flatten, 'improve_this_page' ];
};

has improvethispage_action_path => (
    is => 'ro',
    default => '/improve_this_page',
);


sub improve_this_page {
    my ($self, $c) = @_;
    my $page_details = {
        action => $c->req->action,
        method => $c->req->method,
        uri => $c->req->uri->as_string,
        parameters => $c->req->parameters,
        ($c->req->referer)?(referer => $c->req->referer):(),
    };
    my $email_field = '';
    $email_field = '<label form="email">Email:</label><input type="text" name="email" />' unless ($c->stash->{role});
    return sprintf(q{
        <div id="improve_this_page" title="Improve this page ...">
            <div id="improve_this_page_msg"></div>
            <form action="%s" method="post" id="improve_this_page_form">
               <p>What can we improve on this page ?</p>
               <input type="hidden" name="page_details" value="%s">
               <textarea name="feedback" required="required"></textarea>
               %s
               <input type="submit" value="Send">
               <div id="improve_this_page_loader"></div>
            </form>
        </div>},
        $c->uri_for_action($self->improvethispage_action_path),
        encode_base64(encode("UTF-8",encode_json($page_details))),
        $email_field,
    );
}

1;
